



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>再谈Contacts中姓氏多音字排序错误问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">再谈Contacts中姓氏多音字排序错误问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 21:14:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>说到中国人的名字,那就不得不考虑多音字的问题,比如'单',在作为姓氏时应该读作'shan'而不是'dan'.但是在Contacts程序中却使用的是'D'来作为bucket label!<br />这是为什么？如何解决这种多音字姓氏的问题?</p>
<p>从4.3版本开始,HanziToPinyin.java(ContactsProvider中)改为直接调用ICU的Transliterator来对汉字进行transliterate(详见类中mPinyinTransliterator变量的使用).我们知道,ICU中的Han_Latin_Names.txt中保存了一些汉字在作为姓氏时的读音,如果在创建Transliterator对象时使用Han-Latin/Names作为id(可参考mPinyinTransliterator变量的初始化),将可以正确的获得汉字作为姓氏时的读音(仅限于Han_Latin_Names.txt中包含的汉字).也就是说,HanziToPinyin这个类在处理作为姓氏的多音字时是可以获得正确获得其读音的.如在使用HanziToPinyin获取'单田芳'的读音为'shan tian fang'.就算这样姓名为'单田芳'的联系人依然被排在'D'下面!这是为什么呢?<br />通过解析代码可以发现,联系人排在哪个字母下面是由raw_contacts表中的phonebook_label的值来决定的,而数据库中phonebook_label的值确实是'D',主要是因为在获得phonebook_label时使用的是AlphabeticIndex$ImmutableIndex的getBucketLabel函数,而这个函数是没有对姓氏多音字做任何特殊处理的,所以最后得到的是'D'(phonebook_label的处理流程见附一).</p>
<p>目前,如果想比较省力的解决这个问题,可以在获取phonebook_label时避免通过使用AlphabeticIndex$ImmutableIndex的getBucketLabel函数来获取,而是改为用HanziToPinyin去获得sortKeyPrimary的第一个字符的拼音(sortKeyAlternative暂不考虑).</p>
<p>贴一下代码修改(基于4.4.4_r2)<br />-----------------------------------------------------------------------------<br />--- a/src/com/android/providers/contacts/ContactsDatabaseHelper.java<br />+++ b/src/com/android/providers/contacts/ContactsDatabaseHelper.java<br />@@ -78,6 +78,7 @@ import android.text.util.Rfc822Tokenizer;<br />&nbsp;import android.util.Log;<br />&nbsp;<br />&nbsp;import com.android.common.content.SyncStateContentProviderHelper;<br />+import com.android.providers.contacts.HanziToPinyin.Token;<br />&nbsp;import com.android.providers.contacts.aggregation.util.CommonNicknameCache;<br />&nbsp;import com.android.providers.contacts.database.ContactsTableUtil;<br />&nbsp;import com.android.providers.contacts.database.DeletedContactsTableUtil;<br />@@ -85,6 +86,7 @@ import com.android.providers.contacts.database.MoreDatabaseUtils;<br />&nbsp;import com.android.providers.contacts.util.NeededForTesting;<br />&nbsp;import com.google.android.collect.Sets;<br />&nbsp;<br />+import java.util.ArrayList;<br />&nbsp;import java.util.HashMap;<br />&nbsp;import java.util.Locale;<br />&nbsp;import java.util.Set;<br />@@ -5388,8 +5390,25 @@ public class ContactsDatabaseHelper extends SQLiteOpenHelper {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ContactLocaleUtils localeUtils = ContactLocaleUtils.getInstance();<br />&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; if (sortKeyPrimary != null) {<br />-&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; phonebookBucketPrimary = localeUtils.getBucketIndex(sortKeyPrimary);<br />-&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; phonebookLabelPrimary = localeUtils.getBucketLabel(phonebookBucketPrimary);<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; boolean flag = false;<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; if (displayNameStyle == FullNameStyle.CHINESE<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &amp;&amp; HanziToPinyin.getInstance().hasChineseTransliterator()) {<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; String target = sortKeyPrimary.substring(0, 1);<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ArrayList&lt;Token&gt; tokens = HanziToPinyin.getInstance().get(target);<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; if (tokens != null &amp;&amp; tokens.size() &gt; 0) {<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; char label = tokens.get(0).target.charAt(0);<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; if (label &gt;= 'A' &amp;&amp; label &lt;= 'Z') {<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; phonebookLabelPrimary = String.valueOf(label);<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; phonebookBucketPrimary = localeUtils.getBucketIndex(phonebookLabelPrimary);<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; flag = true;<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />+<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; if (!flag) {<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; phonebookBucketPrimary = localeUtils.getBucketIndex(sortKeyPrimary);<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; phonebookLabelPrimary = localeUtils.getBucketLabel(phonebookBucketPrimary);<br />+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; if (sortKeyAlternative != null) {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; phonebookBucketAlternative = localeUtils.getBucketIndex(sortKeyAlternative);</p>
<p>-----------------------------------------------------------------------------<br />通过上面的分析可以发现一个问题,那就是在Contacts主页面用'dan tian fang'搜索联系人时是搜不到的,只能用'shan<br />
tian<br />
fang'来搜索,但是在显示时确是将该联系人放在了'D'分组下面!根本原因就是NameLookupBuilder在调用<br />
appendNameShorthandLookup时实际上使用了HanziToPinyin来获取读音,这时得到的是作为姓氏时的读音,而<br />
phonebook_label是使用AlphabeticIndex$ImmutableIndex的getBucketLabel函数来获取的,而它<br />
没有对姓氏多音字做任何特殊处理,这就导致了前面说的问题.<br />另外,用HanziToPinyin的一个问题是所有的可作为姓氏的汉字的读音都是姓氏的读音,如'单位单'的拼音是'shan wei shan'.如何解决这个问题呢?其实现有条件下没有一个好的办法(加词库的方法除外),只能尽量规避.我的方法是中文情况下名字中的第一个汉字作为姓氏去获取读音(使用Han-Latin/Names; Latin-Ascii; Any-Upper创建的Transliterator对象),而其它汉字则作为普通汉字去获取读音(使用Han-Latin; Latin-Ascii; Any-Upper创建的Transliterator对象,需在HanziToPinyin中再新建一个Transliterator对象).</p>
<p>附一<br />raw_contacts表中的phonebook_label的获取流程:<br />raw_contacts表中的phonebook_label是通过调用ContactsDatabaseHelper的updateRawContactDisplayName函数来完成插入/更新的.使用的是phonebookLabelPrimary变量的值.而phonebookLabelPrimary是ContactLocaleUtils中getBucketLabel获得的,getBucketLabel中实际调用的是ICU中ImmutableIndex的getBucketLabel来完成的().</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv17eyq.html">Javascript、Jquery获取浏览器和屏幕各种高度宽度</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k2ylj8.html">SVN和CVS的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy6nzj8.html">DWZ错误的解决：0x800a13af - Microsoft JScript 运行时错误&colon; 重新声明常量&OpenCurlyDoubleQuote;document&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93gr008.html">初识React Native，踩坑之旅&period;&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9py5jy9.html">jQuery清除文本框，内容并设置不可用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1v2028.html">js封常用类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd7gp78.html">把一个类（或者Object）转换成字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1wl1x9.html">AsyncHttpClient 登录 Application Fragment 回调 监听 软键盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydp4lgq.html">oracle 定义数据完整性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1dxpk9.html">rsyslog 读日志文件 &comma;当rsyslog 中断时&comma;也会丢数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmy3kx9.html">oracle&amp;amp&semi;&amp;amp&semi;Sqlserver获取表名列名主键及数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eym3jx9.html">&lbrack;SQL基础教程&rsqb; 1-5 表的删除和更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zokxwnq.html">readline与readlines不能同时使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz2z6g8.html">使用EzHttp框架 开发基于HTTP协议的CS轻应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk536z8.html">纯css实现横向下拉菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdv7vd9.html">zTree模糊搜索，显示全部节点和高亮显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r7o749.html">ResNet网络再剖析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4x02m9.html">MySQL基准测试&lpar;二&rpar;--方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7owoz18.html">gdb调试1--包括反汇编及文件编码设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkrrd18.html">mysql系统变量查询</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mjl6x68.html">&lbrack;JavaScript&rsqb; - form表单转json的插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gp46649.html">java 正则表达式验证邮箱格式是否合规  以及 正则表达式元字符</a>
			</li>
						<li><a href="https://www.batexi.com/a/8konzgjq.html">51nod 1102 面积最大的矩形（单调栈）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjl7dp8.html">JDK tools之jps和jstack诊断Java程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2o3vj8.html">python 无序表查找</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmno3w9.html">ros 录制</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjl0v68.html">C&sol;C&plus;&plus;UNION中包含STRUCT</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvezl6z9.html">&lbrack;ios&rsqb;IOS的AppDelegate方法中的事件触发调用  以及 关闭 ios应用程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnyv0dq.html">Chrome开发者工具之JavaScript内存分析&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9637v4y9.html">Grasshopper操作shp</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
